#pragma semicolon 1
#include <PTaH>

public Plugin myinfo =
{
	name = "Weapon Info",
	author = "Phoenix (˙·٠●Феникс●٠·˙)",
	version = "1.0",
	url = "zizt.ru | hlmod.ru | forums.alliedmods.net"
};

KeyValues KV_languages, KV_items;

public void OnPluginStart()
{
	LoadTranslations("weapon_info.phrases");
	
	RegConsoleCmd("sm_wi", wi_);
	RegConsoleCmd("+lookatweapon", lookatweapon_);
	
	char sBuf[512], sPath[128], sPath1[128];
	int pos;
	
	KV_languages = new KeyValues("languages");
	KV_items = new KeyValues("items_game");
	KV_items.ImportFromFile("scripts/items/items_game.txt");
	
	KeyValues KV_buf = new KeyValues("weapon_info");
	if(!KV_buf.ImportFromFile("addons/sourcemod/configs/weapon_info.ini")) SetFailState("[Weapon Info] - Файл конфигураций не найден");
	KV_buf.Rewind();
	KV_buf.JumpToKey("languages");
	KV_buf.GotoFirstSubKey(false);
	do
	{
		KV_buf.GetString("", sPath, sizeof(sPath));
		
		FormatEx(sPath1, sizeof(sPath1), "resource/%s_UTF8.txt", sPath);
		Format(sPath, sizeof(sPath), "resource/%s.txt", sPath);
		
		if(Convert_File_UTF16LE_To_UTF8(sPath, sPath1))
		{
			KV_languages.Rewind();
			KV_buf.GetSectionName(sBuf, sizeof(sBuf));
			KV_languages.JumpToKey(sBuf, true);
			
			File file = OpenFile(sPath1, "r");
			
			while (file.ReadLine(sBuf, sizeof(sBuf)))
			{	
				TrimString(sBuf);
				StripQuotes(sBuf);
				
				if((StrContains(sBuf, "PaintKit_", false) == 0 && StrContains(sBuf, "_Tag\"", false) != -1) || (StrContains(sBuf, "StickerKit_", false) == 0 && StrContains(sBuf, "StickerKit_desc", false) == -1) || StrContains(sBuf, "SFUI_WPNHUD_", false) == 0) //"
				{
					pos = FindCharInString(sBuf, '"');
					sBuf[pos] = 0;
					
					KV_languages.SetString(sBuf, sBuf[pos+FindCharInString(sBuf[pos+1], '"')+2]);
				}
			}
			
			delete file;
			
			DeleteFile(sPath1);
		}
	}
	while KV_buf.GotoNextKey(false);
}

public Action lookatweapon_(int iClient, int args)
{
	if(IsPlayerAlive(iClient))
	{
		int iEnt = GetEntPropEnt(iClient, Prop_Send, "m_hActiveWeapon");
		if(iEnt != -1) DisplayInfo(PTaH_GetEconItemViewFromWeapon(iEnt), iClient);
	}
	else
	{
		if(GetEntProp(iClient, Prop_Send, "m_iObserverMode") == 4)
		{
			int iEnt = GetEntPropEnt(iClient, Prop_Send, "m_hObserverTarget");
			if(iEnt > 0)
			{
				iEnt = GetEntPropEnt(iEnt, Prop_Send, "m_hActiveWeapon");
				if(iEnt != -1) DisplayInfo(PTaH_GetEconItemViewFromWeapon(iEnt), iClient);
			}
		}
	}
	return Plugin_Continue;
}

public Action wi_(int iClient, int args)
{
	Menu Mn = new Menu(DisplayPlayer_);
	char sBuf[64], sBuf1[10];
	
	Mn.SetTitle("%T\n ", "Select player", iClient);
	
	for (int i = 1; i <= MaxClients; i++) if(IsClientInGame(i) && !IsFakeClient(i)) 
	{
		GetClientName(i, sBuf, sizeof(sBuf));
		IntToString(GetClientUserId(i), sBuf1, sizeof(sBuf1));
		Mn.AddItem(sBuf1, sBuf);
	}
	
	Mn.Display(iClient, 0);
	
	return Plugin_Handled;
}

void DisplayInfo(CEconItemView Item, int iClient, bool Back = false)
{
	if(Item && Item.IsCustomItemView())
	{
		char sBuf[1024], sBuf1[161];
		
		CEconItemDefinition ItemDefinition = Item.GetItemDefinition();
		int DefinitionIndex = ItemDefinition.GetDefinitionIndex();
		int StickerSlots = ItemDefinition.GetNumSupportedStickerSlots();
		int PaintKit = Item.GetCustomPaintKitIndex();
		int iTarget = Item.GetClientIndex();
		float PaintKitWear = Item.GetCustomPaintKitWear();
		int PaintKitSeed = Item.GetCustomPaintKitSeed();
		int Quality = Item.GetQuality();
		int Rarity = Item.GetRarity();
		int StatTrak = Item.GetStatTrakKill();
		
		
		Menu Mn = new Menu(DisplayInfo_);
		if(Back) Mn.ExitBackButton = true;
		
		if(PaintKit == 0) sBuf = GetWeaponNameFromDefinitionIndex(DefinitionIndex, iClient);
		else FormatEx(sBuf, sizeof(sBuf), "%s - %s", GetWeaponNameFromDefinitionIndex(DefinitionIndex, iClient), GetPaintKitNameFromIndex(PaintKit, iClient));
		
		if(iTarget == 0) Format(sBuf, sizeof(sBuf), "%s\n%T - %T", sBuf, "Owner", iClient, "Out with the server", iClient);
		else Format(sBuf, sizeof(sBuf), "%s\n%T - %N\n ", sBuf, "Owner", iClient, iTarget);
		
		if(PaintKitWear == -1.0) Format(sBuf, sizeof(sBuf), "%s\n%T - ——", sBuf, "Wear", iClient);
		else Format(sBuf, sizeof(sBuf), "%s\n%T - %T (%f)", sBuf, "Wear", iClient, GetWearNameFromIndex(PaintKitWear), iClient, PaintKitWear);
		
		if(PaintKitSeed == 0) Format(sBuf, sizeof(sBuf), "%s\n\%T - ——", sBuf, "PaintKitSeed", iClient);
		else Format(sBuf, sizeof(sBuf), "%s\n%T - %d", sBuf, "PaintKitSeed", iClient, PaintKitSeed);
		
		if(Quality == 0) Format(sBuf, sizeof(sBuf), "%s\n%T - ——", sBuf, "Quality", iClient);
		else
		{
			if(Quality == 3 && DefinitionIndex > 500) sBuf1 = "Quality_3+9";
			else FormatEx(sBuf1, sizeof(sBuf1), "Quality_%d", Quality);
			Format(sBuf, sizeof(sBuf), "%s\n%T - %T", sBuf, "Quality", iClient, sBuf1, iClient);
		}
		
		FormatEx(sBuf1, sizeof(sBuf1), "Rarity_%d", Rarity);
		Format(sBuf, sizeof(sBuf), "%s\n%T - %T", sBuf, "Rarity", iClient, sBuf1, iClient);
		
		if(StatTrak == -1) Format(sBuf, sizeof(sBuf), "%s\n%T - ——", sBuf, "StatTrak", iClient);
		else Format(sBuf, sizeof(sBuf), "%s\n%T - %d", sBuf, "StatTrak", iClient, StatTrak);
		
		Item.GetCustomName(sBuf1, sizeof(sBuf1));
		if(sBuf1[0]) Format(sBuf, sizeof(sBuf), "%s\n%T - %s", sBuf, "CustomName", iClient, sBuf1);
		else Format(sBuf, sizeof(sBuf), "%s\n%T - ——", sBuf, "CustomName", iClient);
		
		Format(sBuf, sizeof(sBuf), "%s\n%T - %T", sBuf, "Tradable", iClient, Item.IsTradable() ? "Yes":"No", iClient);
		Format(sBuf, sizeof(sBuf), "%s\n%T - %T", sBuf, "Marketable", iClient, Item.IsMarketable() ? "Yes":"No", iClient);
		
		Mn.SetTitle(sBuf);
		
		
		if(Back) IntToString(GetClientUserId(iTarget), sBuf1, sizeof(sBuf1));
		
		//делаем активной кнопочку 6
		Mn.AddItem(sBuf1, "", ITEMDRAW_NOTEXT);
		Mn.AddItem("", "", ITEMDRAW_NOTEXT);
		Mn.AddItem("", "", ITEMDRAW_NOTEXT);
		Mn.AddItem("", "", ITEMDRAW_NOTEXT);
		Mn.AddItem("", "", ITEMDRAW_NOTEXT);
		
		if(StickerSlots != 0)
		{
			int Stickers;
			for (int i; i < StickerSlots; i++) if(Item.GetStickerAttributeBySlotIndex(i, StickerID, 0)) Stickers++;
			if(Stickers > 0)
			{
				FormatEx(sBuf, sizeof(sBuf), "%T - %d", "Stickers", iClient, Stickers);
				if(Back) FormatEx(sBuf1, sizeof(sBuf1), "%d|%d", GetClientUserId(iTarget), Item);
				else IntToString(view_as<int>(Item), sBuf1, sizeof(sBuf1));
				Mn.AddItem(sBuf1, sBuf);
				Mn.Display(iClient, 0);
				return;
			}
		}
		
		FormatEx(sBuf, sizeof(sBuf), "%T - ——", "Stickers", iClient);
		
		Mn.AddItem("", sBuf, ITEMDRAW_DISABLED);
		
		Mn.Display(iClient, 0);
	}
}

public int DisplayInfo_(Menu hMenu, MenuAction action, int iClient, int Item)
{
	switch(action)
	{
		case MenuAction_Select:
		{
			Menu Mn = new Menu(DisplayInfoStickers_);
			Mn.ExitBackButton = true;
			
			char sBuf[1024];
			CEconItemView Item_;
			hMenu.GetItem(5, sBuf, sizeof(sBuf));
			
			Mn.AddItem(sBuf, "", ITEMDRAW_NOTEXT);
			
			int pos = StrContains(sBuf, "|");
			if(pos == -1) Item_ = view_as<CEconItemView>(StringToInt(sBuf));
			else
			{
				sBuf[pos] = 0;
				if(!GetClientOfUserId(StringToInt(sBuf)))
				{
					PrintToChat(iClient, "%t", "PlayerDisconnect");
					wi_(iClient, 0);
					return;
				}
				Item_ = view_as<CEconItemView>(StringToInt(sBuf[pos+1]));
			}
			
			int StickerSlots = Item_.GetItemDefinition().GetNumSupportedStickerSlots();
			
			FormatEx(sBuf, sizeof(sBuf), "%T\n ", "StickerInfo", iClient);
			
			int Sticker;
			float fl;
			
			for (int i; i < StickerSlots; i++)
			{
				Sticker = Item_.GetStickerAttributeBySlotIndex(i, StickerID, 0);
				if(Sticker)
				{
					Format(sBuf, sizeof(sBuf), "%s\n%d - %s", sBuf, i+1, GetStickerNameFromIndex(Sticker, iClient));
					fl = Item_.GetStickerAttributeBySlotIndex(i, WearProgress, 0.0);
					if(fl != 0.0) Format(sBuf, sizeof(sBuf), "%s\n      %T - %f", sBuf, "Wear", iClient, fl);
					fl = Item_.GetStickerAttributeBySlotIndex(i, PatternScale, 0.0);
					if(fl != 0.0) Format(sBuf, sizeof(sBuf), "%s\n      %T - %f", sBuf, "PatternScale", iClient, fl);
					fl = Item_.GetStickerAttributeBySlotIndex(i, PatternRotation, 0.0);
					if(fl != 0.0) Format(sBuf, sizeof(sBuf), "%s\n      %T - %f", sBuf, "PatternRotation", iClient, fl);
				}
			}
			Mn.SetTitle(sBuf);
			
			Mn.Display(iClient, 0);
			
		}
		case MenuAction_Cancel:
		{
			if(Item == MenuCancel_ExitBack)
			{
				char sBuf[10];
				hMenu.GetItem(0, sBuf, sizeof(sBuf));
				int iTarget = GetClientOfUserId(StringToInt(sBuf));
				if(iTarget) DisplayPlayerWeapon(iClient, iTarget);
				else
				{
					PrintToChat(iClient, "%t", "PlayerDisconnect");
					wi_(iClient, 0);
				}
			}
		}
		case MenuAction_End: delete hMenu;
	}
}

public int DisplayInfoStickers_(Menu hMenu, MenuAction action, int iClient, int Item)
{
	if(action == MenuAction_Cancel && Item == MenuCancel_ExitBack)
	{
		char sBuf[20];
		
		hMenu.GetItem(0, sBuf, sizeof(sBuf));
		
		int pos = StrContains(sBuf, "|");
		if(pos == -1) DisplayInfo(view_as<CEconItemView>(StringToInt(sBuf)), iClient);
		else
		{
			sBuf[pos] = 0;
			if(!GetClientOfUserId(StringToInt(sBuf)))
			{
				PrintToChat(iClient, "%t", "PlayerDisconnect");
				wi_(iClient, 0);
				return;
			}
			DisplayInfo(view_as<CEconItemView>(StringToInt(sBuf[pos+1])), iClient, true);
		}
	}
	else if(action == MenuAction_End) delete hMenu;
}

public int DisplayPlayer_(Menu hMenu, MenuAction action, int iClient, int Item)
{
	switch(action)
	{
		case MenuAction_Select:
		{
			char sBuf[10];

			hMenu.GetItem(Item, sBuf, sizeof(sBuf));
			DisplayPlayerWeapon(iClient, GetClientOfUserId(StringToInt(sBuf)));
		}
		case MenuAction_End: delete hMenu;
	}
}

void DisplayPlayerWeapon(int iClient, int iTarget)
{
	char sBuf[128], sBuf1[20];
	Menu Mn = new Menu(DisplayPlayerWeapon_);
	
	Mn.SetTitle("%T\n ", "Select weapon", iClient);
	Mn.ExitBackButton = true;
	
	CEconItemView ItemCT, ItemT;
	
	if(iTarget)
	{
		for (int i; i < 25; i++)
		{
			ItemT = PTaH_GetItemInLoadout(iTarget, 2, i);
			ItemCT = PTaH_GetItemInLoadout(iTarget, 3, i);
			if((ItemT && ItemT.IsCustomItemView()) || (ItemCT && ItemCT.IsCustomItemView()))
			{
				if(ItemT == ItemCT)
				{
					FormatEx(sBuf1, sizeof(sBuf1), "%d|%d", GetClientUserId(iTarget), ItemT);
					FormatEx(sBuf, sizeof(sBuf), "%s [T|CT]", GetWeaponNameFromDefinitionIndex(ItemT.GetItemDefinition().GetDefinitionIndex(), iClient));
				}
				else if(ItemT && ItemT.IsCustomItemView() && ItemCT && ItemCT.IsCustomItemView())
				{
					FormatEx(sBuf1, sizeof(sBuf1), "%d|%d", GetClientUserId(iTarget), ItemT);
					FormatEx(sBuf, sizeof(sBuf), "%s [T]", GetWeaponNameFromDefinitionIndex(ItemT.GetItemDefinition().GetDefinitionIndex(), iClient));
					Mn.AddItem(sBuf1, sBuf);
					FormatEx(sBuf1, sizeof(sBuf1), "%d|%d", GetClientUserId(iTarget), ItemCT);
					FormatEx(sBuf, sizeof(sBuf), "%s [CT]", GetWeaponNameFromDefinitionIndex(ItemCT.GetItemDefinition().GetDefinitionIndex(), iClient));
				}
				else if(ItemT && ItemT.IsCustomItemView())
				{
					FormatEx(sBuf1, sizeof(sBuf1), "%d|%d", GetClientUserId(iTarget), ItemT);
					FormatEx(sBuf, sizeof(sBuf), "%s [T]", GetWeaponNameFromDefinitionIndex(ItemT.GetItemDefinition().GetDefinitionIndex(), iClient));
				}
				else
				{
					FormatEx(sBuf1, sizeof(sBuf1), "%d|%d", GetClientUserId(iTarget), ItemCT);
					FormatEx(sBuf, sizeof(sBuf), "%s [CT]", GetWeaponNameFromDefinitionIndex(ItemCT.GetItemDefinition().GetDefinitionIndex(), iClient));
				}
				Mn.AddItem(sBuf1, sBuf);
			}
		}
		Mn.Display(iClient, 0);
	}
	else
	{
		PrintToChat(iClient, "%t", "PlayerDisconnect");
		wi_(iClient, 0);
	}
}

public int DisplayPlayerWeapon_(Menu hMenu, MenuAction action, int iClient, int Item)
{
	switch(action)
	{
		case MenuAction_Select:
		{
			char sBuf[20];
			hMenu.GetItem(Item, sBuf, sizeof(sBuf));
			int pos = StrContains(sBuf, "|");
			sBuf[pos] = 0;
			int iTarget = GetClientOfUserId(StringToInt(sBuf));
			if(iTarget) DisplayInfo(view_as<CEconItemView>(StringToInt(sBuf[pos+1])), iClient, true);
			else
			{
			}
		}
		case MenuAction_Cancel:
		{
			if(Item == MenuCancel_ExitBack) wi_(iClient, 0);
		}
		case MenuAction_End: delete hMenu;
	}
}


char[] GetWearNameFromIndex(float idx)
{
	char sBuf[3];
	if(idx > 0.45)
	{
		sBuf = "BS";
		return sBuf;
	}
	else if(idx > 0.38)
	{
		sBuf = "WW";
		return sBuf;
	}
	else if(idx > 0.15)
	{
		sBuf = "FT";
		return sBuf;
	}
	else if(idx > 0.7)
	{
		sBuf = "MW";
		return sBuf;
	}
	else
	{
		sBuf = "FN";
		return sBuf;
	}
}

char[] GetStickerNameFromIndex(int indx, int iClient)
{
	char sBuf[128], si[5];
	
	KV_items.Rewind();
	KV_items.JumpToKey("sticker_kits");
	
	IntToString(indx, si, sizeof(si));
	
	do
	{
		if(KV_items.GetSectionName(sBuf, sizeof(sBuf)) && StrEqual(sBuf, "sticker_kits"))
		{
			if(KV_items.JumpToKey(si))
			{
				KV_items.GetString("item_name", sBuf, sizeof(sBuf));
				break;
			}
		}
	}
	while KV_items.GotoNextKey();
	
	return GetTranslation(sBuf[1], iClient);
}

char[] GetPaintKitNameFromIndex(int indx, int iClient)
{
	char sBuf[128], si[5];
	
	KV_items.Rewind();
	KV_items.JumpToKey("paint_kits");
	
	IntToString(indx, si, sizeof(si));
	
	do
	{
		if(KV_items.GetSectionName(sBuf, sizeof(sBuf)) && StrEqual(sBuf, "paint_kits"))
		{
			if(KV_items.JumpToKey(si))
			{
				KV_items.GetString("description_tag", sBuf, sizeof(sBuf));
				break;
			}
		}
	}
	while KV_items.GotoNextKey();
	
	return GetTranslation(sBuf[1], iClient);
}

char[] GetWeaponNameFromDefinitionIndex(int indx, int iClient)
{
	char sBuf[128];
	
	KV_items.Rewind();
	KV_items.JumpToKey("items");
	
	IntToString(indx, sBuf, sizeof(sBuf));
	
	KV_items.JumpToKey(sBuf);
	KV_items.GetString("item_name", sBuf, sizeof(sBuf));
	if(sBuf[0]) return GetTranslation(sBuf[1], iClient);
	
	KV_items.GetString("prefab", sBuf, sizeof(sBuf));
	
	KV_items.Rewind();
	KV_items.JumpToKey("prefabs");
	KV_items.JumpToKey(sBuf);
	KV_items.GetString("item_name", sBuf, sizeof(sBuf));
	
	return GetTranslation(sBuf[1], iClient);
}

char[] GetTranslation(const char[] trn, int iClient)
{
	char sBuf[128];
	GetLanguageInfo(GetClientLanguage(iClient), sBuf, sizeof(sBuf));
	
	KV_languages.Rewind();
	
	if(!KV_languages.JumpToKey(sBuf))
	{
		KV_languages.JumpToKey("en");
		
		KV_languages.GetString(trn, sBuf, sizeof(sBuf), "Translation error");
	}
	else
	{
		KV_languages.GetString(trn, sBuf, sizeof(sBuf));
		
		if(!sBuf[0])
		{
			KV_languages.Rewind();
			
			KV_languages.JumpToKey("en");
			
			KV_languages.GetString(trn, sBuf, sizeof(sBuf), "Translation error");
		}
	}
	
	return sBuf;
}

stock bool Convert_File_UTF16LE_To_UTF8(const char[] sFile, const char[] sFile_output)
{
	File file = OpenFile(sFile, "rb"), file_output = OpenFile(sFile_output, "wb");
	if(!file || !file_output) return false;
	
	// пропускаем заголовок (BOM)
	file.Seek(2, SEEK_SET);
	
	int Int16, char_unicode;
	while (file.ReadUint16(Int16))
	{
		// провиряем нет ли сурогатной пары
		if(Int16 < 0x10000) char_unicode = Int16;
		else
		{
			//переобразовувание сурогатной пары в индекс символа в unicode
			char_unicode = 0x10000;
			char_unicode += (Int16 & 0x03FF) << 10;
			
			file.ReadUint16(Int16);
			
			char_unicode += (Int16 & 0x03FF);
		}
		
		//переобразовувание символа unicode в UTF8 https://gist.github.com/hakre/2351606
		if(char_unicode <= 0x7F) file_output.WriteInt8(char_unicode);
		else if(char_unicode <= 0x7FF)
		{
			file_output.WriteInt8(0xC0 | char_unicode >> 6 & 0x1F);
			file_output.WriteInt8(0x80 | char_unicode & 0x3F);
		}
		else if(char_unicode <= 0xFFFF)
		{
			file_output.WriteInt8(0xE0 | char_unicode >> 12 & 0xF);
			file_output.WriteInt8(0x80 | char_unicode >> 6 & 0x3F);
			file_output.WriteInt8(0x80 | char_unicode & 0x3F);
		}
		else
		{
			file_output.WriteInt8(0xF0 | char_unicode >> 18 & 0x7);
			file_output.WriteInt8(0x80 | char_unicode >> 12 & 0x3F);
			file_output.WriteInt8(0x80 | char_unicode >> 6 & 0x3F);
			file_output.WriteInt8(0x80 | char_unicode & 0x3F);
		}
	}
	
	delete file;
	delete file_output;
	
	return true;
}